#ifndef _SCRIPT_H_
#define _SCRIPT_H_

#include <defs.h>
#include <level.h>
#include <object.h>
#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>

//Default Execution VM.
extern lua_State *lua;

// This will be generated by the Swig wrapper
int luaopen_game (lua_State *);

int l_FindObjectByName (lua_State * L);

//Initialize Scripting
int script_init ();

//Quit Scripting
void script_cleanup ();

//Execute Script File
void script_execute_file (const char *path, level * level);

//Update Object
int script_update_object (object * objptr);

//Reset VM
void script_reset ();

//Add Key-Value to Lua VM.
void script_add_to_dictionary (lua_State * L, char *key, void *value);

//Remove Key from Lua dictionary by assigning to nil value
void script_remove_from_dictionary (char *key);

//Execute "script_init()" function assumed defined in game script
void script_execute_init();

#endif //_SCRIPT_H_
